package src.decision_agent;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import src.IOSTheater;
import src.profiling_agent.ActorProfile;
import src.profiling_agent.ProfilingAgent;
import src.profiling_agent.ATSProfilingAgent;
import java.util.Vector;
import salsa.language.ServiceFactory;
import salsa.messaging.TheaterService;
import salsa.naming.NamingService;
import salsa.naming.UAL;
import salsa.naming.UAN;

public class ATSDecisionActor extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getReception().getLocation() + System.getProperty("identifier"));
		}
		ATSDecisionActor instance = (ATSDecisionActor)new ATSDecisionActor(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new ATSDecisionActor(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return ATSDecisionActor.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new ATSDecisionActor(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return ATSDecisionActor.getReferenceByLocation(new UAL(ual)); }
	public ATSDecisionActor(boolean o, UAN __uan)	{ super(o,__uan); }
	public ATSDecisionActor(boolean o, UAL __ual)	{ super(o,__ual); }

	public ATSDecisionActor(UAN __uan)	{ this(__uan, null); }
	public ATSDecisionActor(UAL __ual)	{ this(null, __ual); }
	public ATSDecisionActor()		{ this(null, null);  }
	public ATSDecisionActor(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getReception().getLocation())) {
			createRemotely(__uan, __ual, "src.decision_agent.ATSDecisionActor");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct () {
		Object[] __arguments = {  };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public ATSDecisionActor self;
		public ATSDecisionActor.State  _this = this;
		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "src.decision_agent.ATSDecisionActor$State" );
			addMethodsForClasses();
		}

		public void updateSelf(ActorReference actorReference) {
			self = (ATSDecisionActor)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
			super.updateSelf(self);
		}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Throwable exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			String exceptionMessage = "Message processing exception:\n";
			if (message.getSource() != null) {
				exceptionMessage += "\tSent by: " + message.getSource().toString() + "\n";
			} else exceptionMessage += "\tSent by: unknown\n";
			exceptionMessage += "\tReceived by actor: " + toString() + "\n";
			exceptionMessage += "\tMessage: " + message.toString() + "\n";
			if (exception == null) {
				if (matches == null) {
					exceptionMessage += "\tNo methods with the same name found.\n";
				System.err.println(exceptionMessage);
					return;
				}
				exceptionMessage += "\tDid not match any of the following: \n";
				for (int i = 0; i < matches.length; i++) {
					exceptionMessage += "\t\tMethod: " + matches[i].getName() + "( ";
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						exceptionMessage += parTypes[j].getName() + " ";
					}
					exceptionMessage += ")\n";
				}
				System.err.println(exceptionMessage);
				return;
			} else {
				exceptionMessage += "\tThrew exception: " + exception + "\n";
				System.err.println(exceptionMessage);
				exception.printStackTrace();
			}
		}

		ATSProfilingAgent profilingAgent = null;
		ActorReference protocolActor = null;
		int sleepTime = 10000;
		long throughput = 0;
		double cw = 0.3, pw = 0.7;
		void construct(){
			protocolActor = IOSTheater.getProtocolActor();
			profilingAgent = (ATSProfilingAgent)IOSTheater.getProfilingAgent();
						{
				// begin()
				{
					Object _arguments[] = {  };
					Message __message = new Message( self, self, "begin", _arguments, null, null );
					__messages.add( __message );
				}
			}
		}
		public void begin() {
			if (System.getProperty("silent")==null) {
				{
					// standardOutput<-println(System.currentTimeMillis()+"\t"+profilingAgent.processed()+"\t\t"+profilingAgent.getActorProfiles().size()+"\t"+profilingAgent.getAvailableProcessing())
					{
						Object _arguments[] = { System.currentTimeMillis()+"\t"+profilingAgent.processed()+"\t\t"+profilingAgent.getActorProfiles().size()+"\t"+profilingAgent.getAvailableProcessing() };
						Message __message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( __message );
					}
				}
			}
			throughput = profilingAgent.processed();
			if (!profilingAgent.isComputing()) 			{
				// protocolActor<-leaveComputation()
				{
					Object _arguments[] = {  };
					Message __message = new Message( self, protocolActor, "leaveComputation", _arguments, null, null );
					__messages.add( __message );
				}
			}
			if (profilingAgent.isLight()&&profilingAgent.isComputing()) {
				{
					// protocolActor<-initiateSteal()
					{
						Object _arguments[] = {  };
						Message __message = new Message( self, protocolActor, "initiateSteal", _arguments, null, null );
						__messages.add( __message );
					}
				}
			}
		}
		private double decisionFunction(ActorProfile candidate, UAL source, double remoteProcessing, Vector actorsAtSource) {
			String localId = protocolActor.getUAL().getLocation();
			String foreignId = source.getLocation();
			double gain;
			double communicationGain, processingGain;
			double localProcessing = profilingAgent.getAvailableProcessing();
			if (localProcessing<0) localProcessing = 0;
			processingGain = (remoteProcessing-localProcessing)/(remoteProcessing+localProcessing);
			double remoteCommunication = 0;
			for (int i = 0; i<actorsAtSource.size(); i++)remoteCommunication += candidate.getCommWith((UAN)actorsAtSource.get(i));
			double localCommunication = 0;
			for (int i = 0; i<profilingAgent.getActors().size(); i++){
				UAN current_uan = (UAN)profilingAgent.getActors().get(i);
				if (!candidate.getUAN().equals(current_uan)) {
					localCommunication += candidate.getCommWith(current_uan);
				}
			}
			communicationGain = (remoteCommunication-localCommunication)/(remoteCommunication+localCommunication);
			if ((remoteCommunication+localCommunication)==0) communicationGain = 0;
			if ((remoteProcessing+localProcessing)==0) processingGain = 0;
			gain = cw*communicationGain+pw*processingGain;
			return gain;
		}
		public ActorReference getBestCandidate(UAL source, double remoteProcessing, Vector actorsAtSource) {
			ActorProfile candidate = null;
			double candidateGain = 0;
			if (!profilingAgent.isComputing()) 			return null;
			Vector actorProfiles = profilingAgent.getActorProfiles();
			for (int i = 0; i<actorProfiles.size(); i++){
				ActorProfile current = (ActorProfile)actorProfiles.get(i);
				double gain = decisionFunction(current, source, remoteProcessing, actorsAtSource);
				System.out.println("\tATS GAIN: "+gain);
				if (gain>candidateGain) {
					candidate = current;
					candidateGain = gain;
				}
			}
			if (candidate!=null) {
				return new UniversalActor(candidate.getUAN());
			}
			return null;
		}
		public Long getThroughput() {
			return new Long(throughput);
		}
	}
}