package src.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import salsa.language.Actor;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.UniversalActor;
import salsa.naming.UAL;
import salsa.naming.UAN;
import src.IOSTheater;
import src.profiling_agent.ProfilingAgent;

public class AutonomousActor extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getReception().getLocation() + System.getProperty("identifier"));
		}
		AutonomousActor instance = (AutonomousActor)new AutonomousActor(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new AutonomousActor(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return AutonomousActor.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new AutonomousActor(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return AutonomousActor.getReferenceByLocation(new UAL(ual)); }
	public AutonomousActor(boolean o, UAN __uan)	{ super(o,__uan); }
	public AutonomousActor(boolean o, UAL __ual)	{ super(o,__ual); }

	public AutonomousActor(UAN __uan)	{ this(__uan, null); }
	public AutonomousActor(UAL __ual)	{ this(null, __ual); }
	public AutonomousActor()		{ this(null, null);  }
	public AutonomousActor(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getReception().getLocation())) {
			createRemotely(__uan, __ual, "src.language.AutonomousActor");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public AutonomousActor self;
		public AutonomousActor.State  _this = this;
		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "src.language.AutonomousActor$State" );
			addMethodsForClasses();
		}

		public void updateSelf(ActorReference actorReference) {
			self = (AutonomousActor)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
			super.updateSelf(self);
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Throwable exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			String exceptionMessage = "Message processing exception:\n";
			if (message.getSource() != null) {
				exceptionMessage += "\tSent by: " + message.getSource().toString() + "\n";
			} else exceptionMessage += "\tSent by: unknown\n";
			exceptionMessage += "\tReceived by actor: " + toString() + "\n";
			exceptionMessage += "\tMessage: " + message.toString() + "\n";
			if (exception == null) {
				if (matches == null) {
					exceptionMessage += "\tNo methods with the same name found.\n";
				System.err.println(exceptionMessage);
					return;
				}
				exceptionMessage += "\tDid not match any of the following: \n";
				for (int i = 0; i < matches.length; i++) {
					exceptionMessage += "\t\tMethod: " + matches[i].getName() + "( ";
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						exceptionMessage += parTypes[j].getName() + " ";
					}
					exceptionMessage += ")\n";
				}
				System.err.println(exceptionMessage);
				return;
			} else {
				exceptionMessage += "\tThrew exception: " + exception + "\n";
				System.err.println(exceptionMessage);
				exception.printStackTrace();
			}
		}

		public transient  ProfilingAgent profilingAgent;
		public void putMessageInMailbox(Message message) {
			if (profilingAgent!=null&&getUAN()!=null&&message.getSource()!=null) {
				profilingAgent.received(getUAN(), message.getSource().getUAN());
			}
			super.putMessageInMailbox(message);
		}
		public void sendGeneratedMessages() {
			for (int i = 0; i<__messages.size(); i++){
				Message message = (Message)__messages.get(i);
				if (profilingAgent!=null&&message.getSource()!=null&&message.getTarget()!=null) {
					profilingAgent.sent(message.getSource().getUAN(), message.getTarget().getUAN());
				}
			}
			super.sendGeneratedMessages();
		}
		public void start_run() {
			standardOutput = ServiceFactory.getOutput();
			standardError = ServiceFactory.getError();
			if (profilingAgent==null) profilingAgent = IOSTheater.getProfilingAgent();
			if (getUAN()!=null) profilingAgent.addProfile(getUAN());
		}
		public void pre_process() {
			if (getUAN()!=null) profilingAgent.beginProcessed(getUAN());
		}
		public void post_process() {
			if (getUAN()!=null) profilingAgent.endProcessed(getUAN());
		}
		public void run() {
			standardOutput = ServiceFactory.getOutput();
			standardError = ServiceFactory.getError();
			if (profilingAgent==null) profilingAgent = IOSTheater.getProfilingAgent();
			if (getUAN()!=null) profilingAgent.addProfile(getUAN());
			while ((!isDestroyed())&&(!isMigrating())&&(!isDead()||!mailbox.isEmpty())) {
				currentMessage = this.getMessage();
				if (getUAN()!=null) profilingAgent.beginProcessed(getUAN());
				this.process(currentMessage);
				if (getUAN()!=null) profilingAgent.endProcessed(getUAN());
				RunTime.finishedProcessingMessage();
			}
		}
		public void destroy() {
			if (getUAN()!=null) profilingAgent.removeProfile(getUAN());
			super.destroy();
		}
		public void migrate(String targetUAL) {
			if (getUAN()!=null) profilingAgent.removeProfile(getUAN());
			super.migrate(targetUAL);
		}
		public void migrate(UAL targetUAL) {
			if (getUAN()!=null) profilingAgent.removeProfile(getUAN());
			super.migrate(targetUAL);
		}
		private void readObject(java.io.ObjectInputStream in) throws Exception{
			in.defaultReadObject();
			profilingAgent = IOSTheater.getProfilingAgent();
			if (getUAN()!=null) profilingAgent.addProfile(getUAN());
		}
	}
}