package src.resources;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class ObservationCollector extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getReception().getLocation() + System.getProperty("identifier"));
		}
		ObservationCollector instance = (ObservationCollector)new ObservationCollector(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new ObservationCollector(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return ObservationCollector.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new ObservationCollector(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return ObservationCollector.getReferenceByLocation(new UAL(ual)); }
	public ObservationCollector(boolean o, UAN __uan)	{ super(o,__uan); }
	public ObservationCollector(boolean o, UAL __ual)	{ super(o,__ual); }

	public ObservationCollector(UAN __uan)	{ this(__uan, null); }
	public ObservationCollector(UAL __ual)	{ this(null, __ual); }
	public ObservationCollector()		{ this(null, null);  }
	public ObservationCollector(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getReception().getLocation())) {
			createRemotely(__uan, __ual, "src.resources.ObservationCollector");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct (long wait_time, long iterations) {
		Object[] __arguments = { new Long(wait_time), new Long(iterations) };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public ObservationCollector self;
		public ObservationCollector.State  _this = this;
		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "src.resources.ObservationCollector$State" );
			addMethodsForClasses();
		}

		public void updateSelf(ActorReference actorReference) {
			self = (ObservationCollector)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
			super.updateSelf(self);
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Throwable exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			String exceptionMessage = "Message processing exception:\n";
			if (message.getSource() != null) {
				exceptionMessage += "\tSent by: " + message.getSource().toString() + "\n";
			} else exceptionMessage += "\tSent by: unknown\n";
			exceptionMessage += "\tReceived by actor: " + toString() + "\n";
			exceptionMessage += "\tMessage: " + message.toString() + "\n";
			if (exception == null) {
				if (matches == null) {
					exceptionMessage += "\tNo methods with the same name found.\n";
				System.err.println(exceptionMessage);
					return;
				}
				exceptionMessage += "\tDid not match any of the following: \n";
				for (int i = 0; i < matches.length; i++) {
					exceptionMessage += "\t\tMethod: " + matches[i].getName() + "( ";
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						exceptionMessage += parTypes[j].getName() + " ";
					}
					exceptionMessage += ")\n";
				}
				System.err.println(exceptionMessage);
				return;
			} else {
				exceptionMessage += "\tThrew exception: " + exception + "\n";
				System.err.println(exceptionMessage);
				exception.printStackTrace();
			}
		}

		long wait_time = 30000;
		long iterations = 100;
		String[] locations = new String[0];
		ActorReference[] protocol_agents = new ActorReference[0];
		ActorReference[] references = new ActorReference[0];
		void construct(long wait_time, long iterations){
			this.wait_time = wait_time;
			this.iterations = iterations;
		}
		public void initiate_collection() {
			System.err.println("Starting ObservationCollector.");
			{
				// randomly_reconfigure_application()
				{
					Object _arguments[] = {  };
					Message __message = new Message( self, self, "randomly_reconfigure_application", _arguments, null, null );
					__messages.add( __message );
				}
			}
		}
		public void register_actor(ActorReference actor) {
			System.err.println("Registering actor: "+actor.getUAN());
			int i;
			ActorReference[] temp = new ActorReference[references.length+1];
			for (i = 0; i<references.length; i++){
				temp[i] = references[i];
			}
			temp[i] = actor;
			references = temp;
		}
		public void register_location(String location) {
			location = location.substring(0, location.length()-1);
			System.err.println("Registering location: "+location);
			System.err.println("locations.length: "+locations.length);
			System.err.println("protocol_agents.length: "+protocol_agents.length);
			int i = 0;
			String[] temp = new String[locations.length+1];
			ActorReference[] temp2 = new ActorReference[protocol_agents.length+1];
			for (i = 0; i<locations.length; i++){
				temp[i] = locations[i];
				temp2[i] = protocol_agents[i];
			}
			temp[i] = location;
			temp2[i] = (ActorReference)UniversalActor.getReferenceByLocation(location+"/io/protocolActor");
			locations = temp;
			protocol_agents = temp2;
		}
		public void gather_observations() {
			System.err.println("Gathering observations");
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<protocol_agents.length; i++){
					{
						// protocol_agents[i]<-gather_observation()
						{
							Object _arguments[] = {  };
							Message __message = new Message( self, protocol_agents[i], "gather_observation", _arguments, null, token_2_0 );
							__messages.add( __message );
						}
					}
				}
				token_2_0.createJoinDirector();
				// print_responses(token)
				{
					Object _arguments[] = { token_2_0 };
					Message __message = new Message( self, self, "print_responses", _arguments, token_2_0, token_2_1 );
					__messages.add( __message );
				}
				// randomly_reconfigure_application()
				{
					Object _arguments[] = {  };
					Message __message = new Message( self, self, "randomly_reconfigure_application", _arguments, token_2_1, null );
					__messages.add( __message );
				}
			}
		}
		public void print_responses(Object[] responses) {
			for (int i = 0; i<responses.length; i++){
				System.out.println(responses[i]);
			}
		}
		public void randomly_reconfigure_application() {
			System.err.println("randomly reconfiguring application.");
			if (iterations>0) {
				String random_location = locations[(int)(java.lang.Math.random()*(double)locations.length)];
				Token wait_token = new Token("wait_token");
				{
					// token wait_token = references[0]<-migrate(random_location+references[0].getUAL().getIdentifier())
					{
						Object _arguments[] = { random_location+references[0].getUAL().getIdentifier() };
						Message __message = new Message( self, references[0], "migrate", _arguments, null, wait_token );
						__messages.add( __message );
					}
				}
				for (int i = 1; i<references.length; i++){
					random_location = locations[(int)(java.lang.Math.random()*(double)locations.length)];
					{
						// wait_token = references[i]<-migrate(random_location+references[i].getUAL().getIdentifier())
						Token wait_token_next = new Token("<-_next");
						{
							Object _arguments[] = { random_location+references[i].getUAL().getIdentifier() };
							Message __message = new Message( self, references[i], "migrate", _arguments, null, wait_token_next );
							Object[] _propertyInfo = { wait_token };
							__message.setProperty( "waitfor", _propertyInfo );
							__messages.add( __message );
						}
						wait_token = wait_token_next;
					}
				}
				{
					// ()reset_profiling_agents:((wait_token))
					{
						Object _arguments[] = {  };
						Message __message = new Message( self, self, "reset_profiling_agents", _arguments, null, null );
						Object[] _propertyInfo = { wait_token };
						__message.setProperty( "waitfor", _propertyInfo );
						__messages.add( __message );
					}
				}
				iterations--;
			}
		}
		public void reset_profiling_agents() {
			System.err.println("resetting profiling agents");
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<protocol_agents.length; i++){
					{
						// protocol_agents[i]<-reset_profiling_agent()
						{
							Object _arguments[] = {  };
							Message __message = new Message( self, protocol_agents[i], "reset_profiling_agent", _arguments, null, token_2_0 );
							__messages.add( __message );
						}
					}
				}
				token_2_0.createJoinDirector();
				// delay()
				{
					Object _arguments[] = {  };
					Message __message = new Message( self, self, "delay", _arguments, token_2_0, null );
					__messages.add( __message );
				}
			}
		}
		public void delay() {
			{
				// ()gather_observations:((new Long(wait_time)))
				{
					Object _arguments[] = {  };
					Message __message = new Message( self, self, "gather_observations", _arguments, null, null );
					Object[] _propertyInfo = { new Long(wait_time) };
					__message.setProperty( "delay", _propertyInfo );
					__messages.add( __message );
				}
			}
		}
	}
}